/* gjid03.c                         freeware                   xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include <stdio.h>
#include <math.h>
#include "mydefine.h"
#include "mydata.h"
#include "myprint.h"     /* printm printrow printcol                          */
#include "mycopy.h"      /*  copym  copyrow  copycol                          */
#include "myspecm.h"     /* identity, zero matrix                             */
#include "myfmint.h"     /* rownmini divide a row by a integer if possible    */
#include "myelemrowop.h" /* Elementary row operations. swaprow multrow addrow */
#include "myfmop.h"      /* add, multiply two matrices. transpose             */
#include "myfpivot.h"    /* pivotntzero pivotwork                             */
#include "myfdet.h"      /* det, minor, cofactor, mcofactor, adjoint          */
#include "mygauss.h"     /* gauss gaussjordan                                 */
#include "myid.h"        /* gaussjordan(), inverse() with the identity matrix */
#include "myid2.h"       /* gaussjordan(), inverse() with the identity matrix */
#include "myid3.h"       /* gaussjordan(), inverse() with the identity matrix */
#include "myid4.h"       /* gaussjordan(), inverse() with the identity matrix */

/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
 main()
{

double pblock[3][4*TWOCOL]=
{
  14,1,  -16,1,  -19,1,  15,1,
  13,1,   13,1,   12,1, -14,1,
 -12,1,   17,1,  -13,2,  12,1,
};
matrix m={3,4*TWOCOL,&pblock[0][0]};

double pblockT   [3][4*TWOCOL]; matrix mT    ={3,4*TWOCOL,&pblockT   [0][0]};
double pblockT2  [3][4*TWOCOL]; matrix mT2   ={3,4*TWOCOL,&pblockT2  [0][0]};
double pblockT3  [3][4*TWOCOL]; matrix mT3   ={3,4*TWOCOL,&pblockT3  [0][0]};
double pblockT4  [3][4*TWOCOL]; matrix mT4   ={3,4*TWOCOL,&pblockT4  [0][0]};

double pblockID  [3][3*TWOCOL]; matrix mID   ={3,3*TWOCOL,&pblockID  [0][0]};
double pblockIDT1[3][3*TWOCOL]; matrix mIDT1 ={3,3*TWOCOL,&pblockIDT1[0][0]};
double pblockIDT2[3][3*TWOCOL]; matrix mIDT2 ={3,3*TWOCOL,&pblockIDT2[0][0]};

/*-------------------------------- PROGRAM ---------------------------------- */
 copymF(&m,&mT3);
 copymF(&m,&mT4);

 printf("\n");
 printf(" The matrix  mA \n");
 printmF(&m);
  getchar();

 printf(" Find mID (below the pivots) \n");
 idF4(&mID,&mIDT1,&mIDT2,&mT,&mT2,&m);
 printmF(&mID);
 getchar();

 printf("  mID * mA  \n");
 multmF(&mID,&mT3,&m);
 printmF(&m);
 getchar();

 copymF(&m,&mT3);

 printf(" Find mID (above the pivots) \n");
 idF4a(&mID,&mIDT1,&mIDT2,&mT,&mT2,&m);
 printmF(&mID);
 getchar();

 printf("  mID * mA  \n");
 multmF(&mID,&mT3,&m);
 printmF(&m);
 getchar();

 printf(" Verify with gaussjordanF(); \n");
 copymF(&mT4,&m);
 gaussjordanF(&m);
 printmF(&m);

 printf("\n Press a key to continue");
 getchar();
}



